package jndi.test;

import javax.naming.InitialContext;
import javax.naming.NameNotFoundException;
import javax.naming.NamingException;

import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

public class JndiBindJob implements Job
{

	@Override
	public void execute(JobExecutionContext jCtx) throws JobExecutionException
	{
		long tm = System.currentTimeMillis(); 
		//
		String _oldVar = (String) jCtx.getJobDetail().getJobDataMap().get("oldVar");
		SessInfo si = (SessInfo) jCtx.getJobDetail().getJobDataMap().get("si");
		String _newVar = TestBindJNDIPortlet.VAR_TO_BIND_BASE + "_" + tm;
				
		bindToInitialContext(_oldVar, _newVar, "A" + tm );
		si.setCurrVal(_newVar );
	}

	private void bindToInitialContext(String oldVar, String newVar, String _tm)
	{
		boolean bNotFound = false;
		String oldVal = "";
		
		synchronized(TestBindJNDIPortlet.VAR_TO_BIND_BASE)
		{
			InitialContext ctx = null;
			
			try
			{
			//
				
				ctx = new InitialContext();
				
				try
				{
					if ( oldVar != null )
						oldVal = (String) ctx.lookup(oldVar);
				}
				catch(NameNotFoundException ex)
				{
					bNotFound = true;
				}
				
				
				// Prima unbind
				if ( !bNotFound && oldVar != null ) {
					System.out.println(" >>> Unbinding \"" + oldVar + "\" - val: \"" + oldVal + "\"" );
					ctx.unbind(oldVar);
				}
				
				//
				ctx.bind(newVar, _tm);
				System.out.println(" >>>>>>>>> Bound in \"" + newVar + "\": \"" + _tm + "\"" );
				
				_tm = (String) ctx.lookup(newVar);
				System.out.println("\n >>>>>>>>> Reading (from Job): \"" + _tm + "\"" );
				
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
			finally
			{
				if ( ctx != null ) 
				{
					try
					{
						ctx.close();
					}
					catch (NamingException e)
					{
						e.printStackTrace();
					}
				}
				
			}
		} // synchronized
	}
	
} // Fine Classe
