package jndi.test;

import java.io.IOException;
import java.util.Date;

import javax.naming.InitialContext;
import javax.naming.NameNotFoundException;
import javax.naming.NamingException;
import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletContext;
import javax.portlet.PortletException;
import javax.portlet.PortletRequestDispatcher;
import javax.portlet.ProcessAction;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.WindowState;

import org.quartz.JobBuilder;
import org.quartz.JobDataMap;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.SchedulerException;
import org.quartz.Trigger;
import org.quartz.TriggerBuilder;

public class TestBindJNDIPortlet extends GenericPortlet
{
	
	public final static String VAR_TO_BIND_BASE = "varToBind";
	
	//
	public TestBindJNDIPortlet()
	{
		System.out.println(">>> TestBindJNDIPortlet::ctor() ");
	}

	
	@Override
	protected void doView(RenderRequest request, RenderResponse response)
			throws PortletException, IOException
	{
		WindowState state = request.getWindowState();
		
        if (state.equals(WindowState.MINIMIZED)) {
            super.doView(request, response);

            return;
        }
        
        ////////////////////////
        
        // 
        PortletContext context = getPortletContext();
        PortletRequestDispatcher rd = null;

        try {

            // Setto la pagina della View
            rd = context.getRequestDispatcher("/jsp/pagina.jsp");

            if (rd != null)
                rd.include(request, response);
        } 
        catch (IOException e) 
        {
        	e.printStackTrace();
        }
        catch(PortletException pe)
        {
        	throw pe;
        }
        
	}
	
	
	@ProcessAction(name="doBindData")
	public void doBindData(ActionRequest request, ActionResponse response)
			throws PortletException, IOException, SchedulerException
	{
				
		// Recupera il precedente 
		SessInfo si = (SessInfo) request.getPortletSession().getAttribute("SESS_INFO");
		if ( si == null ) {
			si = new SessInfo(null);
			request.getPortletSession().setAttribute("SESS_INFO", si);
		}

		System.out.println("\n>>> CURR_VAL: " + si.getCurrVal() );
		
		//
		JobDataMap params = new JobDataMap();
		params.put("oldVar", si.getCurrVal() );
		params.put("si", si);
		//
		Scheduler sched = TestSchedulingUtility.getScheduler();			
        JobDetail job = JobBuilder.newJob(JndiBindJob.class).usingJobData(params).build();
        
        TriggerBuilder<Trigger> builder = TriggerBuilder.newTrigger();
        Trigger trigger = builder
            .startAt(new Date())
            .build();
        sched.scheduleJob(job, trigger);
		
	}

	@ProcessAction(name="doReadData")
	public void doReadData(ActionRequest request, ActionResponse response)
			throws PortletException, IOException
	{
		String readValue = null;
		
		try
		{
			SessInfo si = (SessInfo) request.getPortletSession().getAttribute("SESS_INFO");

			if ( si != null ) {
				readValue = readFromContext( si.getCurrVal() );
				System.out.println("\n >>> Reading (from Portlet) - " + si.getCurrVal() + ": \"" + readValue + "\"" );
			}
			else
			{
				System.out.println("\n >>> SessInfo is null !");
			}

			readValue = ">> \"" + readValue + "\""; 
			response.setRenderParameter("readValue", readValue);
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		
	}

	//
	private String readFromContext(String var) throws NamingException
	{
		synchronized(VAR_TO_BIND_BASE)
		{
			InitialContext ctx = null;
			
			try
			{
				ctx = new InitialContext();
				String retVal = (String) ctx.lookup(var);
				return retVal;
			}
			catch(NameNotFoundException nnfe)
			{
				return nnfe.getMessage();
			}
			finally
			{
				if ( ctx != null ) ctx.close();
			}
		}
	}
	
		
}  // Fine Classe
